--[[
Working on aimware
by qi
]]

--gui
local X, Y = draw.GetScreenSize()
local Ref = gui.Reference("Misc", "General", "Extra")
local keyingInd_Enable = gui.Checkbox(Ref, "keyingsind", "Show Keyings", 1)
local keyingInd_Clr = gui.ColorPicker(keyingInd_Enable, "clr", "clr", 7, 7, 7, 100)
local keyingInd_Clr2 = gui.ColorPicker(keyingInd_Enable, "clr2", "clr2", 255, 0, 0, 255)
local keyingInd_rgb = gui.Checkbox(keyingInd_Enable, "rgb", "rgb", 0)
local keyingInd_X = gui.Slider(keyingInd_Enable, "x", "x", 400, 0, X)
local keyingInd_Y = gui.Slider(keyingInd_Enable, "y", "y", 400, 0, Y)

local DT_Ref = gui.Reference("Ragebot", "Accuracy", "Weapon")
keyingInd_Enable:SetDescription("Displays the active binding key.")
keyingInd_rgb:SetInvisible(true)
keyingInd_X:SetInvisible(true)
keyingInd_Y:SetInvisible(true)

--var
local renderer = {}
local tX, tY, offsetX, offsetY, _drag
local MENU = gui.Reference("MENU")
local font = draw.CreateFont("Verdana", 12)

local alpha = 0
local alpha2 = 0
local hsalpha = 0
local dtalpha = 0
local swalpha = 0
local fdalpha = 0
local lbyalpha = 0
local trgalpha = 0
local sbalpha = 0

--function

--ElementExists
local function Element(varname)
    gui.GetValue(varname)
end
local function ElementExists(varname)
    local Element = pcall(Element, varname)
    return Element
end

--Mouse drag
local function is_inside(a, b, x, y, w, h) 
    return 
    a >= x and a <= w and b >= y and b <= h 
end

local function drag_menu(x, y, w, h)
    if not MENU:IsActive() then
        return tX, tY
    end
    local mouse_down = input.IsButtonDown(1)
    if mouse_down then
        local X, Y = input.GetMousePos()
        if not _drag then
            local w, h = x + w, y + h
            if is_inside(X, Y, x, y, w, h) then
                offsetX, offsetY = X - x, Y - y
                _drag = true
            end
        else
            tX, tY = X - offsetX, Y - offsetY
            keyingInd_X:SetValue(tX) 
            keyingInd_Y:SetValue(tY)
        end
    else
        _drag = false
    end
    return tX, tY
end

--renderer text
renderer.text = function(x, y, clr, shadow, string, font, flags)

    local alpha = 255
    local textW, textH = draw.GetTextSize(string)

    if font ~= nil then
        draw.SetFont(font)
    end

    if clr[4] ~= nil then
        alpha = clr[4]
    end

    if flags == "c" then
        x = x - (textW / 2)
    elseif flags == "l" then
        x = x - textW
    elseif flags == "r" then
        x = x + textW
    end

    if shadow  then
        draw.Color(0, 0, 0, alpha)
        draw.Text(x + 1, y + 1, string)
    end

    draw.Color(clr[1], clr[2], clr[3], alpha)
	draw.Text(x, y, string)
    alpha = nil
    x, y = nil
end

--renderer rectangle
renderer.rectangle = function(x, y, w, h, clr, fill, radius)

    local alpha = 255

    if clr[4] ~= nil then
        alpha = clr[4]
    end

    draw.Color(clr[1], clr[2], clr[3], alpha)

    if fill then
        draw.FilledRect(x, y, x + w, y + h)
    else
        draw.OutlinedRect(x, y, x + w, y + h)
    end

    if fill == "shadow" then
        draw.ShadowRect(x, y, x + w, y + h, radius)
    end

    alpha = nil
end

--renderer gradient
renderer.gradient = function(x, y, w, h, clr, clr1, vertical)
    
    local r, g, b, a = clr1[1], clr1[2], clr1[3], clr1[4]
	local r1, g1, b1, a1 = clr[1], clr[2], clr[3], clr[4]

    if a and a1 == nil then
        a, a1 = 255, 255
    end

    if vertical then
        if clr1[4] ~= 0 then
            if a1 and a ~= 255 then
                for i = 0, w do
                    local a2 = i / w * a1
                    renderer.rectangle(x, y + w - i, w, 1, {r1, g1, b1, a2}, true)
                end
            else
                renderer.rectangle(x, y, w, h, {r1, g1, b1, a1}, true)
            end
        end
        if a2 ~= 0 then
            for i = 0, h do
                local a2 = i / h * a
                renderer.rectangle(x, y + i, w, 1, {r, g, b, a2}, true)
            end
        end
    else
        if clr[4] ~= 0 then
            if a1 and a ~= 255 then
                for i = 0, w do
                    local a2 = i / w * a1
                    renderer.rectangle(x + w - i, y, 1, h, {r1, g1, b1, a2}, true)
                end
            else
                renderer.rectangle(x, y, w, h, {r1, g1, b1, a1}, true)
            end
        end
        if a2 ~= 0 then
            for i = 0, w do
                local a2 = i / w * a
                renderer.rectangle(x + i, y, 1, h, {r, g, b, a2}, true)
            end
        end
    end
    a, a1 = nil, nil
end

--alpha
local function alpha_stop(val, min, max)
    if val < min then return min end
    if val > max then return max end
    return val
end

--rgb
local function hue2rgb(p, q, t)
    if (t < 0) then t = t + 1 end
    if (t > 1) then t = t - 1 end
    if (t < 1/6) then return p + (q - p) * 6 * t end
    if (t < 1/2) then return q end
    if (t < 2/3) then return p + (q - p) * (2/3 - t) * 6 end
    return p
end
local function hslToRgb(h, s, l)
    local r, g, b
  
    if (s == 0) then
        r = l
        g = l
        b = l
    else
        local q = 0
        if(l < 0.5) then
            q = l * (1 + s)
        else
            q = l + s - l * s
        end

        local p = 2 * l - q
    
        r = hue2rgb(p, q, h + 1/3)
        g = hue2rgb(p, q, h)
        b = hue2rgb(p, q, h - 1/3)
    end
    return{r * 255, g * 255, b * 255}
end

local function Clamp(val, min, max)
    if(val > max) then
        return max 
    elseif(val < min) then
        return min 
    else 
        return val 
    end
end

--Get the correct name of the weapon
local function MenuWeapon(var)
    local Weapon_selection = string.match(var, [["(.+)"]])
    if Weapon_selection == "Heavy Pistol" then
        Weapon_selection = "hpistol"
    elseif Weapon_selection == "Auto Sniper" then
        Weapon_selection = "asniper"
    elseif Weapon_selection == "Submachine Gun" then
        Weapon_selection = "Smg"
    elseif Weapon_selection == "Light Machine Gun" then
        Weapon_selection = "Lmg"
    end
    local Weapon = string.lower(Weapon_selection)
    return Weapon
end

--Let drag position save
local function PositionSave()
    if tX ~= keyingInd_X:GetValue() or tY ~= keyingInd_Y:GetValue() then
        tX = keyingInd_X:GetValue()
        tY = keyingInd_Y:GetValue()
    end
end

local function OnKey()

    local wid = entities.GetLocalPlayer():GetWeaponID()

    local x, y = drag_menu(tX, tY, 100, 100)
    local r, g, b, a = 255, 255, 255, 255
    local rgb = hslToRgb((globals.CurTime() / Clamp(100 - 90, 1, 100)) % 1, 1, 0.5)
    local r2, g2, b2, a2 = keyingInd_Clr:GetValue()
    local r3, g3, b3, a3 = keyingInd_Clr2:GetValue()
    local fade_factor = ((1.0 / 0.15) * globals.FrameTime()) * 250
    local i = 0
    local xi = 0

    local DtWeapon = MenuWeapon(DT_Ref:GetValue())
    local rbot_master = gui.GetValue("rbot.master")
    local shiftonshot = gui.GetValue("rbot.antiaim.condition.shiftonshot")
    local lby = gui.GetValue("rbot.antiaim.base.lby")
    local slowkey = gui.GetValue("rbot.accuracy.movement.slowkey")
    local fakecrouchkey = gui.GetValue("rbot.antiaim.extra.fakecrouchkey")

    local lbot_master = gui.GetValue("lbot.master")
    local trgenable = gui.GetValue("lbot.trg.enable")
    local trgkey = gui.GetValue("lbot.trg.key")
    local trgauto = gui.GetValue("lbot.trg.autofire")

    local misc_master = gui.GetValue("misc.master")
    local sbenable = gui.GetValue("misc.speedburst.enable")
    local sbkey = gui.GetValue("misc.speedburst.key")

    if rbot_master and shiftonshot then
        hsalpha = alpha_stop(hsalpha + fade_factor, 0, a)
    else
        hsalpha = alpha_stop(hsalpha - fade_factor, 0, a)
    end

    if rbot_master and (wid == 1 or wid == 2 or wid == 3 or wid == 4 or wid == 30 or wid == 32 or wid == 36 or wid == 61 or wid == 63 or wid == 7 or wid == 8 or wid == 10 or wid == 13 or wid == 16 or wid == 39 or wid == 60 or wid == 11 or wid == 38 or wid == 17 or wid == 19 or wid == 23 or wid == 24 or wid == 26 or wid == 33 or wid == 34 or wid == 14 or wid == 28 or wid == 25 or wid == 27 or wid == 29 or wid == 35) and gui.GetValue("rbot.accuracy.weapon."..DtWeapon..".doublefire") > 0 then
        dtalpha = alpha_stop(dtalpha + fade_factor, 0, a)
    else
        dtalpha = alpha_stop(dtalpha - fade_factor, 0, a)
    end

    if rbot_master and slowkey ~= 0 and input.IsButtonDown(slowkey) then
        swalpha = alpha_stop(swalpha + fade_factor, 0, a)
    else
        swalpha = alpha_stop(swalpha - fade_factor, 0, a)
    end
    
    if rbot_master and fakecrouchkey ~= 0 and input.IsButtonDown(fakecrouchkey) then
        fdalpha = alpha_stop(fdalpha + fade_factor, 0, a)
    else
        fdalpha = alpha_stop(fdalpha - fade_factor, 0, a)
    end

    if rbot_master and lby < 0 then
        lbyalpha = alpha_stop(lbyalpha + fade_factor, 0, a)
    else
        lbyalpha = alpha_stop(lbyalpha - fade_factor, 0, a)
    end

    if lbot_master and trgenable and trgkey ~= 0 and input.IsButtonDown(trgkey) then
        trgalpha = alpha_stop(trgalpha + fade_factor, 0, a)
    elseif lbot_master and trgenable and trgauto then
        trgalpha = alpha_stop(trgalpha + fade_factor, 0, a)
    else
        trgalpha = alpha_stop(trgalpha - fade_factor, 0, a)
    end

    if misc_master and sbenable and sbkey ~= 0 and input.IsButtonDown(sbkey) then
        sbalpha = alpha_stop(sbalpha + fade_factor, 0, a)
    else
        sbalpha = alpha_stop(sbalpha - fade_factor, 0, a)
    end

    if lbyalpha ~= 0 then
        xi = 20
        renderer.text(x + 5, y + 25 + i, {r, g, b, lbyalpha}, true, "Anti-aim inverter", font)
        renderer.text(x + 80 + xi, y + 25 + i, {r, g, b, lbyalpha}, true, "[toggled]", font)
        i = i + 15
    end

    if hsalpha ~= 0 then
        renderer.text(x + 5, y + 25 + i, {r, g, b, hsalpha}, true, "Hide shots", font)
        renderer.text(x + 80 + xi, y + 25 + i, {r, g, b, hsalpha}, true, "[toggled]", font)
        i = i + 15
    end

    if dtalpha ~= 0 then
        renderer.text(x + 5, y + 25 + i, {r, g, b, dtalpha}, true, "Double fire", font)
        renderer.text(x + 80 + xi, y + 25 + i, {r, g, b, dtalpha}, true, "[toggled]", font)
        i = i + 15
    end

    if swalpha ~= 0 then
        renderer.text(x + 5, y + 25 + i, {r, g, b, swalpha}, true, "Slow walk", font)
        renderer.text(x + 80 + xi, y + 25 + i, {r, g, b, swalpha}, true, "[holding]", font)
        i = i + 15
    end

    if fdalpha ~= 0 then
        renderer.text(x + 5, y + 25 + i, {r, g, b, fdalpha}, true, "Fake duck", font)
        renderer.text(x + 80 + xi, y + 25 + i, {r, g, b, fdalpha}, true, "[holding]", font)
        i = i + 15
    end

    if trgalpha ~= 0 then
        renderer.text(x + 5, y + 25 + i, {r, g, b, trgalpha}, true, "Trigger", font)
        renderer.text(x + 80 + xi, y + 25 + i, {r, g, b, trgalpha}, true, "[holding]", font)
        i = i + 15
    end

    if sbalpha ~= 0 then
        renderer.text(x + 5, y + 25 + i, {r, g, b, sbalpha}, true, "Speed burst", font)
        renderer.text(x + 80 + xi, y + 25 + i, {r, g, b, sbalpha}, true, "[holding]", font)
        i = i + 15
    end

    if i > 0 or MENU:IsActive() then
        alpha = alpha_stop(alpha + fade_factor, 0, 255)
    else
        alpha = alpha_stop(alpha - fade_factor, 0, 255)
    end

    if xi ~= 0 then
        alpha2 = alpha_stop(alpha2 + fade_factor, 0, 60)
    else
        alpha2 = alpha_stop(alpha2 - fade_factor, 0, 60)
    end

    renderer.rectangle(x, y + 2, 130 + alpha2 * 0.3, 18, {r2, g2, b2, alpha * a2 / 255}, true)
    renderer.rectangle(x, y, 130 + alpha2 * 0.3, 2, {r3, g3, b3, alpha * a3 / 255}, true)
    renderer.text(x + 45 + (alpha2 * 0.3 * 0.5), y + 5, {255, 255, 255, alpha}, true, "keybinds", font)  

    if keyingInd_rgb:GetValue() then
        renderer.gradient(x, y, 129 + alpha2 * 0.3, 2, {rgb[1], rgb[2], rgb[3], alpha}, {rgb[2], rgb[3], rgb[1], alpha}, false)
    end

end

--Callbacks
callbacks.Register("Draw", function()
    if entities.GetLocalPlayer() then
        if keyingInd_Enable:GetValue() then
            PositionSave()
            OnKey()
        end
    end

    
end)

--end